{********************************************************************************}
{ Ajedrez 1.0 - Juego del ajedrez bajo ms-dos.                                   }
{ Copyright (C) 2005  Gorka Surez Garca                                        }
{                                                                                }
{ Pintado.pas is part of "Ajedrez".                                              }
{                                                                                }
{ "Ajedrez" is free software; you can redistribute it and/or                     }
{ modify it under the terms of the GNU General Public License                    }
{ as published by the Free Software Foundation; either version 2                 }
{ of the License, or (at your option) any later version.                         }
{                                                                                }
{ "Ajedrez" is distributed in the hope that it will be useful,                   }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of                 }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  }
{ GNU General Public License for more details.                                   }
{                                                                                }
{ You should have received a copy of the GNU General Public License              }
{ along with "Ajedrez"; if not, write to the Free Software                       }
{ Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.    }
{********************************************************************************}
unit Pintado;
{********************************************************************************}
interface {parte publica}
uses Lesslib, Nucleo, crt;
{********************************************************************************}
{ Funciones para pintar la pantalla.                                             }
{********************************************************************************}
procedure PintarPantalla (var Nucleo: tNucleo);


{********************************************************************************}
implementation {parte privada}
{********************************************************************************}


{********************************************************************************}
{ Funcin que pinta una linea horizontal.                                        }
{********************************************************************************}
procedure PintarLineaH (xi, xf, y: word; color: byte);
var
   i: word;
begin
   for i := xi to xf do
      M13hPixelPoner(i, y, color);
end;

{********************************************************************************}
{ Funcin que pinta una linea vertical.                                          }
{********************************************************************************}
procedure PintarLineaV (x, yi, yf: word; color: byte);
var
   i: word;
begin
   for i := yi to yf do
      M13hPixelPoner(x, i, color);
end;

{********************************************************************************}
{ Funcin que pinta un rectangulo.                                               }
{********************************************************************************}
procedure PintarRectangulo (xi, xf, yi, yf: word; color: byte);
begin
   PintarLineaH(xi, xf, yi, color);
   PintarLineaV(xi, yi, yf, color);
   PintarLineaV(xf, yi, yf, color);
   PintarLineaH(xi, xf, yf, color);
end;

{********************************************************************************}
{ Funcin que pinta un cuadro de dilogo, indicndole una cadena con el mensaje, }
{ y la posicin x en la que se va a centrar dicho mensaje.                       }
{********************************************************************************}
procedure PintarDialogo (var Nucleo: tNucleo; mensaje: string; x: word);
begin
   {-----------------------------------------------------------------------------}
   { Borramos la pantalla y escribimos el mensaje del cuadro de dilogo.         }
   {-----------------------------------------------------------------------------}
   M13hBorrarPantalla(COL_NEGRO);

   FuenteEscribir(mensaje, x, 50, COL_TXTDLG, Nucleo.Fuente);

   {-----------------------------------------------------------------------------}
   { Iluminamos el botn "S" si el ratn est encima.                           }
   {-----------------------------------------------------------------------------}
   if RatonEstaEn2(Nucleo.Raton, Nucleo.Texturas.DlgBotones[BOT_DLG_SI]) then
      M13hImagenPegar8(Nucleo.Texturas.DlgBotones[BOT_DLG_SI].x,
         Nucleo.Texturas.DlgBotones[BOT_DLG_SI].y,
         Nucleo.Texturas.PosBotones[BOT_SI],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave)
   else
      M13hImagenPegar8(Nucleo.Texturas.DlgBotones[BOT_DLG_SI].x,
         Nucleo.Texturas.DlgBotones[BOT_DLG_SI].y,
         Nucleo.Texturas.PosBotones[BOT_SI_NORMAL],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave);

   {-----------------------------------------------------------------------------}
   { Iluminamos el botn "No" si el ratn est encima.                           }
   {-----------------------------------------------------------------------------}
   if RatonEstaEn2(Nucleo.Raton, Nucleo.Texturas.DlgBotones[BOT_DLG_NO]) then
      M13hImagenPegar8(Nucleo.Texturas.DlgBotones[BOT_DLG_NO].x,
         Nucleo.Texturas.DlgBotones[BOT_DLG_NO].y,
         Nucleo.Texturas.PosBotones[BOT_NO],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave)
   else
      M13hImagenPegar8(Nucleo.Texturas.DlgBotones[BOT_DLG_NO].x,
         Nucleo.Texturas.DlgBotones[BOT_DLG_NO].y,
         Nucleo.Texturas.PosBotones[BOT_NO_NORMAL],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave);
end;

{********************************************************************************}
{ Funcin que pinta la pantalla del men.                                        }
{********************************************************************************}
procedure PintarMenu (var Nucleo: tNucleo);
begin
   {-----------------------------------------------------------------------------}
   { Pintamos el fondo del men.                                                 }
   {-----------------------------------------------------------------------------}
   M13hImagenPegar(0, 0, Nucleo.Texturas.Menu);

   {-----------------------------------------------------------------------------}
   { Iluminamos el botn "1 Jugador" si el ratn est encima.                    }
   {-----------------------------------------------------------------------------}
   if RatonEstaEn2(Nucleo.Raton, Nucleo.Texturas.MnuBotones[BOT_MNU_1JUGADORES]) then
      M13hImagenPegar8(Nucleo.Texturas.MnuBotones[BOT_MNU_1JUGADORES].x,
         Nucleo.Texturas.MnuBotones[BOT_MNU_1JUGADORES].y,
         Nucleo.Texturas.PosBotones[BOT_1JUGADORES],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave);

   {-----------------------------------------------------------------------------}
   { Iluminamos el botn "2 Jugadores" si el ratn est encima.                  }
   {-----------------------------------------------------------------------------}
   if RatonEstaEn2(Nucleo.Raton, Nucleo.Texturas.MnuBotones[BOT_MNU_2JUGADORES]) then
      M13hImagenPegar8(Nucleo.Texturas.MnuBotones[BOT_MNU_2JUGADORES].x,
         Nucleo.Texturas.MnuBotones[BOT_MNU_2JUGADORES].y,
         Nucleo.Texturas.PosBotones[BOT_2JUGADORES],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave);

   {-----------------------------------------------------------------------------}
   { Iluminamos el botn "Cargar" si el ratn est encima.                       }
   {-----------------------------------------------------------------------------}
   if RatonEstaEn2(Nucleo.Raton, Nucleo.Texturas.MnuBotones[BOT_MNU_CARGAR]) then
      M13hImagenPegar8(Nucleo.Texturas.MnuBotones[BOT_MNU_CARGAR].x,
         Nucleo.Texturas.MnuBotones[BOT_MNU_CARGAR].y,
         Nucleo.Texturas.PosBotones[BOT_CARGAR],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave);

   {-----------------------------------------------------------------------------}
   { Iluminamos el botn "Ayuda" si el ratn est encima.                        }
   {-----------------------------------------------------------------------------}
   if RatonEstaEn2(Nucleo.Raton, Nucleo.Texturas.MnuBotones[BOT_MNU_AYUDA]) then
      M13hImagenPegar8(Nucleo.Texturas.MnuBotones[BOT_MNU_AYUDA].x,
         Nucleo.Texturas.MnuBotones[BOT_MNU_AYUDA].y,
         Nucleo.Texturas.PosBotones[BOT_AYUDA],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave);

   {-----------------------------------------------------------------------------}
   { Iluminamos el botn "Salir" si el ratn est encima.                        }
   {-----------------------------------------------------------------------------}
   if RatonEstaEn2(Nucleo.Raton, Nucleo.Texturas.MnuBotones[BOT_MNU_SALIR]) then
      M13hImagenPegar8(Nucleo.Texturas.MnuBotones[BOT_MNU_SALIR].x,
         Nucleo.Texturas.MnuBotones[BOT_MNU_SALIR].y,
         Nucleo.Texturas.PosBotones[BOT_SALIR],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave);
end;

{********************************************************************************}
{ Funcin que pinta el tablero con la partida actual en curso.                   }
{********************************************************************************}
procedure PintarTablero (var Nucleo: tNucleo);
var
   i, j, k: integer;
begin
   {-----------------------------------------------------------------------------}
   { Pintamos el fondo.                                                          }
   {-----------------------------------------------------------------------------}
   M13hImagenPegar(0, 0, Nucleo.Texturas.Tablero);

   {-----------------------------------------------------------------------------}
   { Iluminamos el botn "Reiniciar" si el ratn est encima.                    }
   {-----------------------------------------------------------------------------}
   if RatonEstaEn2(Nucleo.Raton, Nucleo.Texturas.TabBotones[BOT_TAB_REINICIAR]) then
      M13hImagenPegar8(Nucleo.Texturas.TabBotones[BOT_TAB_REINICIAR].x,
         Nucleo.Texturas.TabBotones[BOT_TAB_REINICIAR].y,
         Nucleo.Texturas.PosBotones[BOT_REINICIAR],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave);

   {-----------------------------------------------------------------------------}
   { Iluminamos el botn "Salvar" si el ratn est encima.                       }
   {-----------------------------------------------------------------------------}
   if RatonEstaEn2(Nucleo.Raton, Nucleo.Texturas.TabBotones[BOT_TAB_SALVAR]) then
      M13hImagenPegar8(Nucleo.Texturas.TabBotones[BOT_TAB_SALVAR].x,
         Nucleo.Texturas.TabBotones[BOT_TAB_SALVAR].y,
         Nucleo.Texturas.PosBotones[BOT_SALVAR],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave);

   {-----------------------------------------------------------------------------}
   { Iluminamos el botn "Cargar" si el ratn est encima.                       }
   {-----------------------------------------------------------------------------}
   if RatonEstaEn2(Nucleo.Raton, Nucleo.Texturas.TabBotones[BOT_TAB_CARGAR]) then
      M13hImagenPegar8(Nucleo.Texturas.TabBotones[BOT_TAB_CARGAR].x,
         Nucleo.Texturas.TabBotones[BOT_TAB_CARGAR].y,
         Nucleo.Texturas.PosBotones[BOT_CARGAR],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave);

   {-----------------------------------------------------------------------------}
   { Iluminamos el botn "Ayuda" si el ratn est encima.                        }
   {-----------------------------------------------------------------------------}
   if RatonEstaEn2(Nucleo.Raton, Nucleo.Texturas.TabBotones[BOT_TAB_AYUDA]) then
      M13hImagenPegar8(Nucleo.Texturas.TabBotones[BOT_TAB_AYUDA].x,
         Nucleo.Texturas.TabBotones[BOT_TAB_AYUDA].y,
         Nucleo.Texturas.PosBotones[BOT_AYUDA],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave);

   {-----------------------------------------------------------------------------}
   { Iluminamos el botn "Salir" si el ratn est encima.                        }
   {-----------------------------------------------------------------------------}
   if RatonEstaEn2(Nucleo.Raton, Nucleo.Texturas.TabBotones[BOT_TAB_SALIR]) then
      M13hImagenPegar8(Nucleo.Texturas.TabBotones[BOT_TAB_SALIR].x,
         Nucleo.Texturas.TabBotones[BOT_TAB_SALIR].y,
         Nucleo.Texturas.PosBotones[BOT_SALIR],
         Nucleo.Texturas.Botones, Nucleo.Texturas.CClave);

   {-----------------------------------------------------------------------------}
   { Pintamos las piezas en sus respectivas posiciones.                          }
   {-----------------------------------------------------------------------------}
   for i := FICHA_BLANCA to FICHA_NEGRA do
      for j := 1 to MAX_FICHAS_JUG do
         if Nucleo.Juego.Fichas[i, j].Tipo <> FICHA_MUERTA then
          begin
            k := Nucleo.Juego.Fichas[i, j].Tipo;
            M13hImagenPegar8((Nucleo.Juego.Fichas[i, j].Columna - 1) * TAB_SEP_X + TAB_POS_X,
               (8 - Nucleo.Juego.Fichas[i, j].Fila) * TAB_SEP_Y + TAB_POS_Y,
               Nucleo.Texturas.PosFichas[k, i], Nucleo.Texturas.Fichas,
               Nucleo.Texturas.CClave);
          end;

   {-----------------------------------------------------------------------------}
   { Pintamos un cuadrado con la casilla seleccionada.                           }
   {-----------------------------------------------------------------------------}
   if (0 < Nucleo.Juego.selx) and (Nucleo.Juego.selx < 9) and
      (0 < Nucleo.Juego.sely) and (Nucleo.Juego.sely < 9) then
      PintarRectangulo((Nucleo.Juego.selx - 1) * TAB_SEP_X + TAB_POS_X,
         (Nucleo.Juego.selx - 1) * TAB_SEP_X + TAB_POS_X + (TAB_SEP_X - 1),
         (8 - Nucleo.Juego.sely) * TAB_SEP_Y + TAB_POS_Y,
         (8 - Nucleo.Juego.sely) * TAB_SEP_Y + TAB_POS_Y + (TAB_SEP_Y - 1),
         COL_CASSEL);

   {-----------------------------------------------------------------------------}
   { Pintamos en caso de estar activado, alguno de los mensajes para el usuario. }
   {-----------------------------------------------------------------------------}
   case Nucleo.Juego.Mensaje of
      MSJ_MOVINV:
       begin
         FuenteEscribir('Movimiento', 216, 171, COL_TXTMSJ, Nucleo.Fuente);
         FuenteEscribir(' invalido!',  216, 185, COL_TXTMSJ, Nucleo.Fuente);
       end;

      MSJ_JAQUEB:
       begin
         FuenteEscribir('Jaque al',   216, 171, COL_TXTMSJ, Nucleo.Fuente);
         FuenteEscribir('rey blanco!', 216, 185, COL_TXTMSJ, Nucleo.Fuente);
       end;

      MSJ_JAQUEN:
       begin
         FuenteEscribir('Jaque al',  216, 171, COL_TXTMSJ, Nucleo.Fuente);
         FuenteEscribir('rey negro!', 216, 185, COL_TXTMSJ, Nucleo.Fuente);
       end;

      MSJ_MOVINVJ:
       begin
         FuenteEscribir('Jaque mate', 216, 171, COL_TXTMSJ, Nucleo.Fuente);
         FuenteEscribir(' si mueves!', 216, 185, COL_TXTMSJ, Nucleo.Fuente);
       end;

      MSJ_ENROQUE:
       begin
         FuenteEscribir('Imposible', 216, 171, COL_TXTMSJ, Nucleo.Fuente);
         FuenteEscribir(' enrocar!',  216, 185, COL_TXTMSJ, Nucleo.Fuente);
       end;

      MSJ_JAQUEMB:
       begin
         FuenteEscribir('Jaque mate',    216, 171, COL_TXTMSJ, Nucleo.Fuente);
         FuenteEscribir('al rey blanco!', 216, 185, COL_TXTMSJ, Nucleo.Fuente);
       end;

      MSJ_JAQUEMN:
       begin
         FuenteEscribir('Jaque mate',   216, 171, COL_TXTMSJ, Nucleo.Fuente);
         FuenteEscribir('al rey negro!', 216, 185, COL_TXTMSJ, Nucleo.Fuente);
       end;
   end;
end;

{********************************************************************************}
{ Funcin que pinta el estado actual del juego.                                  }
{********************************************************************************}
procedure PintarJuego (var Nucleo: tNucleo);
begin
   case Nucleo.Juego.Victoria of
      {--------------------------------------------------------------------------}
      { Pintamos el tablero si todava no hay una victoria.                      }
      {--------------------------------------------------------------------------}
      VICTORIA_NO:
       begin
         PintarTablero(Nucleo);
       end;

      {--------------------------------------------------------------------------}
      { Ganan las blancas.                                                       }
      {--------------------------------------------------------------------------}
      VICTORIA_J1:
       begin
         PintarDialogo(Nucleo, 'Desea jugar otra partida?', 69);

         if Nucleo.Juego.Estado = EST_1JUG then
          begin
            FuenteEscribir('Gana el jugador!', 100, 0, COL_TXTVIC, Nucleo.Fuente);
            PintarLineaH(100, 219, 14, COL_TXTSAL);
          end
         else
          begin
            FuenteEscribir('Gana el jugador 1!', 93, 0, COL_TXTVIC, Nucleo.Fuente);
            PintarLineaH(93, 226, 14, COL_TXTSAL);
          end;
       end;

      {--------------------------------------------------------------------------}
      { Ganan las negras.                                                        }
      {--------------------------------------------------------------------------}
      VICTORIA_J2:
       begin
         PintarDialogo(Nucleo, 'Desea jugar otra partida?', 69);

         if Nucleo.Juego.Estado = EST_1JUG then
          begin
            FuenteEscribir('Gana la maquina!', 100, 0, COL_TXTVIC, Nucleo.Fuente);
            PintarLineaH(100, 219, 14, COL_TXTSAL);
          end
         else
          begin
            FuenteEscribir('Gana el jugador 2!', 93, 0, COL_TXTVIC, Nucleo.Fuente);
            PintarLineaH(93, 226, 14, COL_TXTSAL);
          end;
       end;

      {--------------------------------------------------------------------------}
      { Ganan las negras.                                                        }
      {--------------------------------------------------------------------------}
      JUEGO_TABLAS:
       begin
         PintarDialogo(Nucleo, 'Desea jugar otra partida?', 69);

         FuenteEscribir('Juego en tablas!', 100, 0, COL_TXTVIC, Nucleo.Fuente);
         PintarLineaH(100, 219, 14, COL_TXTSAL);
       end;
   end;
end;

{********************************************************************************}
{ Funcin que pinta los nombres de las partidas guardadas.                       }
{********************************************************************************}
procedure PintarPartidas (var Nucleo: tNucleo);
var
   i: integer;
begin
   for i := 1 to MAX_PARTIDAS do
    begin
      {--------------------------------------------------------------------------}
      { Pintamos primero un rectngulo donde va a ir el nombre.                  }
      {--------------------------------------------------------------------------}
      PintarRectangulo(PART_INITX, PART_INITX + PART_INITW,
         PART_INITY + PART_SEP_Y * (i - 1),
         (PART_INITY + PART_INITH) + PART_SEP_Y * (i - 1), COL_BLANCO);

      {--------------------------------------------------------------------------}
      { Y despus pintamos el nombre dentro de dicho rectngulo.                 }
      {--------------------------------------------------------------------------}
      FuenteEscribir(Nucleo.Partidas.Nombre[i], PART_INITX + 2,
         (PART_INITY + 1) + PART_SEP_Y * (i - 1), COL_BLANCO, Nucleo.Fuente);
    end;
end;

{********************************************************************************}
{ Funcin que pinta la pantalla de salvar la partida.                            }
{********************************************************************************}
procedure PintarSalvar (var Nucleo: tNucleo);
begin
   case Nucleo.Partidas.Estado of
      PART_EST_NORMAL:
       begin
         {-----------------------------------------------------------------------}
         { Borramos la pantalla y escribimos el ttulo de la ventana.            }
         {-----------------------------------------------------------------------}
         M13hBorrarPantalla(COL_NEGRO);

         FuenteEscribir('Salvar juego', 118, 0, COL_TXTSAL, Nucleo.Fuente);
         PintarLineaH(118, 202, 14, COL_TXTSAL);

         {-----------------------------------------------------------------------}
         { Pintamos los nombres de las partidas.                                 }
         {-----------------------------------------------------------------------}
         PintarPartidas(Nucleo);
       end;
      PART_EST_AVISO:
         PintarDialogo(Nucleo, 'Desea guardar sobre esa partida?', 44);
      PART_EST_METER:
       begin
         {-----------------------------------------------------------------------}
         { Borramos la pantalla y escribimos el ttulo de la ventana.            }
         {-----------------------------------------------------------------------}
         M13hBorrarPantalla(COL_NEGRO);

         FuenteEscribir('Salvar juego', 118, 0, COL_TXTSAL, Nucleo.Fuente);
         PintarLineaH(118, 202, 14, COL_TXTSAL);

         {-----------------------------------------------------------------------}
         { Y escribimos el texto actual del nombre de la partida.                }
         {-----------------------------------------------------------------------}
         FuenteEscribir('Introduzca el nombre de la partida:', 10, 86, COL_TXTSAL, Nucleo.Fuente);
         FuenteEscribir(Nucleo.Partidas.Auxcad, 10, 100, COL_TXTSAL, Nucleo.Fuente);
       end;
   end;
end;

{********************************************************************************}
{ Funcin que pinta la pantalla de cargar la partida.                            }
{********************************************************************************}
procedure PintarCargar (var Nucleo: tNucleo);
begin
   case Nucleo.Partidas.Estado of
      PART_EST_NORMAL:
       begin
         {-----------------------------------------------------------------------}
         { Borramos la pantalla y escribimos el ttulo de la ventana.            }
         {-----------------------------------------------------------------------}
         M13hBorrarPantalla(COL_NEGRO);

         FuenteEscribir('Cargar juego', 118, 0, COL_TXTCAR, Nucleo.Fuente);
         PintarLineaH(118, 202, 14, COL_TXTSAL);

         {-----------------------------------------------------------------------}
         { Pintamos los nombres de las partidas.                                 }
         {-----------------------------------------------------------------------}
         PintarPartidas(Nucleo);
       end;
      PART_EST_AVISO:
         PintarDialogo(Nucleo, 'Desea cargar esa partida?', 69);
   end;
end;

{********************************************************************************}
{ Funcin que pinta la ayuda del juego.                                          }
{********************************************************************************}
procedure PintarAyuda (var Nucleo: tNucleo);
begin {320/2 = 160}
   {-----------------------------------------------------------------------------}
   { Primera pgina de ayuda. Movimiento del pen y de la torre.                 }
   {-----------------------------------------------------------------------------}
   M13hBorrarPantalla(COL_NEGRO);

   FuenteEscribir('Ayuda del juego', 107, 0, COL_TXTTIT, Nucleo.Fuente);
   PintarLineaH(107, 212, 14, COL_TXTTIT);

   {             ('*********************************************')}
   FuenteEscribir('Las reglas bsicas de este juego son:',        3, 16, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('+ El pen se mueve una casilla hacia delante', 3, 30, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  o dos casillas la primera vez que mueve.',   3, 44, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  Para comer, come en diagonal una casilla.',  3, 58, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  Si un pen enemigo se moviera 2 casillas,',  3, 72, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  para evitar ser comido, se le podra comer', 3, 86, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  moviendo nuestro peon a la casilla donde',   3, 100, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  hubiera estado de haber movido solo una.',   3, 114, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('+ La torre se mueve y come moviendose en',     3, 128, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  linea, a travs de fila en la que est, o',  3, 142, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  de la columna en la que se encuentre.',      3, 156, COL_TXTAYU, Nucleo.Fuente);

   FuenteEscribir('Pulse una tecla para continuar...', 3, 184, COL_TXTCON, Nucleo.Fuente);
   M13hActualizarPantalla; readkey;

   {-----------------------------------------------------------------------------}
   { Segunda pgina de ayuda. Movimiento del alfil y del caballo.                }
   {-----------------------------------------------------------------------------}
   M13hBorrarPantalla(COL_NEGRO);

   FuenteEscribir('Ayuda del juego', 107, 0, COL_TXTTIT, Nucleo.Fuente);
   PintarLineaH(107, 212, 14, COL_TXTTIT);

   {             ('*********************************************')}
   FuenteEscribir('+ El alfil se mueve y come moviendose en',     3, 16, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  linea, a travs de las dos diagonales que',  3, 30, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  se cruzan en su casilla.',                   3, 44, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('+ El caballo se mueve en forma de L, y es la', 3, 58, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  nica ficha que puede saltar a las dems.',  3, 72, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  Ejemplo:',                                   3, 86, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('                   XX',                     3, 100, COL_TXTEJE, Nucleo.Fuente);
   FuenteEscribir('   C=Caballo       XX',                     3, 114, COL_TXTEJE, Nucleo.Fuente);
   FuenteEscribir('   X=Casilla       C',                     3, 128, COL_TXTEJE, Nucleo.Fuente);
   FuenteEscribir('     final         XX',                     3, 142, COL_TXTEJE, Nucleo.Fuente);
   FuenteEscribir('                   XX',                     3, 156, COL_TXTEJE, Nucleo.Fuente);

   FuenteEscribir('Pulse una tecla para continuar...', 3, 184, COL_TXTCON, Nucleo.Fuente);
   M13hActualizarPantalla; readkey;

   {-----------------------------------------------------------------------------}
   { Tercera pgina de ayuda. Movimiento de la reina y del rey.                  }
   {-----------------------------------------------------------------------------}
   M13hBorrarPantalla(COL_NEGRO);

   FuenteEscribir('Ayuda del juego', 107, 0, COL_TXTTIT, Nucleo.Fuente);
   PintarLineaH(107, 212, 14, COL_TXTTIT);

   {             ('*********************************************')}
   FuenteEscribir('+ La reina se mueve igual que la torre y el',   3, 16, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  alfil juntos, siendo la pieza ms poderosa,', 3, 30, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  que tiene el ajedrez.',                       3, 44, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('+ Y finalmente el rey sera como la reina,',    3, 58, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  pero solo se puede mover una casilla, salvo', 3, 72, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  con la jugada del enroque. Esta consiste en', 3, 86, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  mover el rey a la columna G o C, y la torre', 3, 100, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  a la columna F si es la torre derecha, o a',  3, 114, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  la columna D si es la torre izquierda, con',  3, 128, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  la que hemos efectuado el enroque. Esta ju-', 3, 142, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  gada solo se puede hacer si el rey, y la...', 3, 156, COL_TXTAYU, Nucleo.Fuente);

   FuenteEscribir('Pulse una tecla para continuar...', 3, 184, COL_TXTCON, Nucleo.Fuente);
   M13hActualizarPantalla; readkey;

   {-----------------------------------------------------------------------------}
   { Cuarta pgina de ayuda. Objetivo y crditos mnimos del juego.              }
   {-----------------------------------------------------------------------------}
   M13hBorrarPantalla(COL_NEGRO);

   FuenteEscribir('Ayuda del juego', 107, 0, COL_TXTTIT, Nucleo.Fuente);
   PintarLineaH(107, 212, 14, COL_TXTTIT);

   {             ('*********************************************')}
   FuenteEscribir('  torre que vamos a enrocar, no se han movido', 3, 16, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  todava. Adems no puede haber ninguna',      3, 30, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  ficha enemiga amenazando el trayecto que',    3, 44, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  efectua el rey, al hacer la jugada. Y',       3, 58, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  tampoco se puede hacer si nos tienen en',     3, 72, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  jaque.',                                      3, 86, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('+ El objetivo del juego es matar al rey del',   3, 100, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('  ejercito contrario.',                         3, 114, COL_TXTAYU, Nucleo.Fuente);

   FuenteEscribir('Grficos y programacin por Gorka Surez',      3, 142, COL_TXTAYU, Nucleo.Fuente);
   FuenteEscribir('Garca, alias "Alexander Lessman".',            3, 156, COL_TXTAYU, Nucleo.Fuente);

   FuenteEscribir('Pulse una tecla para volver al men...', 3, 184, COL_TXTCON, Nucleo.Fuente);
   M13hActualizarPantalla; readkey;
end;

{********************************************************************************}
{ Funcin que pinta el cuadro de dilogo de salir del juego.                     }
{********************************************************************************}
procedure PintarSalir1 (var Nucleo: tNucleo);
begin
   PintarDialogo(Nucleo, 'Desea salir del juego?', 79);
end;

{********************************************************************************}
{ Funcin que pinta el cuadro de dilogo de salir de la partida.                 }
{********************************************************************************}
procedure PintarSalir2 (var Nucleo: tNucleo);
begin
   PintarDialogo(Nucleo, 'Desea salir de la partida?', 65);
end;

{********************************************************************************}
{ Funcin que pinta el cuadro de dilogo de reiniciar la partida.                }
{********************************************************************************}
procedure PintarReiniciar (var Nucleo: tNucleo);
begin
   PintarDialogo(Nucleo, 'Desea reiniciar el juego?', 69);
end;

{********************************************************************************}
{ Funcin principal que gestiona el pintado de la pantalla en el juego.          }
{********************************************************************************}
procedure PintarPantalla (var Nucleo: tNucleo);
begin
   {-----------------------------------------------------------------------------}
   { Seleccionamos, dependiendo del estado del juego, una funcin para pintar    }
   { en cada uno de los estados del juego.                                       }
   {-----------------------------------------------------------------------------}
   case Nucleo.Juego.Estado of
      EST_MENU:       PintarMenu(Nucleo);
      EST_1JUG:       PintarJuego(Nucleo);
      EST_2JUG:       PintarJuego(Nucleo);
      EST_SALVAR1:    PintarSalvar(Nucleo);
      EST_SALVAR2:    PintarSalvar(Nucleo);
      EST_CARGAR1:    PintarCargar(Nucleo);
      EST_CARGAR2:    PintarCargar(Nucleo);
      EST_CARGAR3:    PintarCargar(Nucleo);
      EST_AYUDA1:     PintarAyuda(Nucleo);
      EST_AYUDA2:     PintarAyuda(Nucleo);
      EST_AYUDA3:     PintarAyuda(Nucleo);
      EST_SALIR1:     PintarSalir1(Nucleo);
      EST_SALIR2:     PintarSalir2(Nucleo);
      EST_SALIR3:     PintarSalir2(Nucleo);
      EST_REINICIAR1: PintarReiniciar(Nucleo);
      EST_REINICIAR2: PintarReiniciar(Nucleo);
   end;

   {-----------------------------------------------------------------------------}
   { En caso de que no estemos en la pantalla de ayuda, pintamos el cursor, y    }
   { luego actualizamos el contenido de la pantalla.                             }
   {-----------------------------------------------------------------------------}
   if (Nucleo.Juego.Estado < EST_AYUDA1) or (EST_AYUDA3 < Nucleo.Juego.Estado) then
    begin
      if Nucleo.Raton.bi then
         M13hImagenPegar8(Nucleo.Raton.x, Nucleo.Raton.y,
            Nucleo.Texturas.PosCursor[CUR_COGER],
            Nucleo.Texturas.Cursor, Nucleo.Texturas.CClave)
      else
         M13hImagenPegar8(Nucleo.Raton.x, Nucleo.Raton.y,
            Nucleo.Texturas.PosCursor[CUR_NORMAL],
            Nucleo.Texturas.Cursor, Nucleo.Texturas.CClave);

      M13hActualizarPantalla;
    end;
end;

{********************************************************************************}
end.
{********************************************************************************}